/*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void
on_xcave_button_about_clicked (GtkButton * button,
		  gpointer user_data)
{
    XCAVE_DEBUG_B;
  
	/* 
	 * desactive window_xcave
	 */
	gtk_widget_set_sensitive(window_xcave, FALSE);

	window_about = create_xcave_about ();

	GtkWidget		*textAbout;
	textAbout = lookup_widget(window_about,"xcave_about_textview");

	gchar buf[1024];
	memset (buf,'\0',1024);
	sprintf(buf,_("\n\nxcave %s\n\nhttp://xcave.free.fr\n\nxcave is wine cellar manager software\n\n\nxcave@free.fr"),VERSION);

	gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (textAbout)),	buf, -1);

	gtk_widget_show (window_about);

	/*
     hbox = gtk_hbox_new (TRUE, 0);
     href = gnome_href_new ("http://xcave.free.fr/", _("xcave home page"));
     gtk_box_pack_start (GTK_BOX (hbox), href, FALSE, FALSE, 0);
     gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (window_about)->vbox), hbox, TRUE, FALSE, 0);
     gtk_widget_show_all (hbox);
    */
    XCAVE_DEBUG_E;

}

void
on_xcave_about_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (window_about));

   /* 
    * reactive window_xcave
    */
   gtk_widget_set_sensitive(window_xcave, TRUE);

}


void
on_xcave_about_button_close_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (window_about));

   /* 
    * reactive window_xcave
    */
   gtk_widget_set_sensitive(window_xcave, TRUE);
}
