/*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void
on_xcave_button_synthese_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
    GList	*tmp_list_region;

    XCAVE_DEBUG_B;
  
    /* 
     * desactive window_xcave
     */
    gtk_widget_set_sensitive(window_xcave, FALSE);

    window_synthese = create_xcave_synthese();

    /*
     * redimensionnement de la fenetre
     */
    if ( strlen(WindowsSyntheseHeight) != 0 && strlen (WindowsSyntheseWidth) != 0 ) {
   gtk_window_set_default_size (GTK_WINDOW (window_synthese), 
                                       atoi(WindowsSyntheseWidth), 
                                       atoi(WindowsSyntheseHeight));
    }
    gtk_widget_show (window_synthese);
	
    /* 
     * REGION STAT
     */
    gint ind = 0;
	
    gchar tmp_buf[80];

    gint  tmp_nb = g_list_length(list_region)+1;	

    GtkWidget *xcave_synthese_hbox_region[tmp_nb];
    GtkWidget *xcave_synthese_vbox_region;
    GtkWidget *xcave_synthese_entry_region1[tmp_nb];
    GtkWidget *xcave_synthese_entry_region2[tmp_nb];
    GtkWidget *xcave_synthese_progressbar_region[tmp_nb];
    GtkWidget *xcave_synthese_frame_region;

    xcave_synthese_frame_region = lookup_widget(window_synthese,"xcave_synthese_frame_region");
    xcave_synthese_vbox_region = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (xcave_synthese_vbox_region);
    gtk_container_add (GTK_CONTAINER (xcave_synthese_frame_region),
					   xcave_synthese_vbox_region);

    for(tmp_list_region  = list_region; 
	tmp_list_region != NULL ; 
	tmp_list_region  = tmp_list_region->next) {
            
	if ((tmp_nb = calculate_nb_bottle(CALCULATE_REGION, tmp_list_region->data, 0)) != 0) {
                        	
               xcave_synthese_hbox_region[ind] = gtk_hbox_new (FALSE, 0);
               gtk_widget_show (xcave_synthese_hbox_region[ind]);
               gtk_box_pack_start (GTK_BOX (xcave_synthese_vbox_region),
				   xcave_synthese_hbox_region[ind],
				   TRUE, TRUE, 0);

               /*
		* entry region
		*/
	       memset(tmp_buf,'\0',sizeof(tmp_buf));
               sprintf(tmp_buf,_("%s"),(gchar *)tmp_list_region->data);
               xcave_synthese_entry_region1[ind] = gtk_entry_new ();
               gtk_widget_show (xcave_synthese_entry_region1[ind]);
               gtk_box_pack_start (GTK_BOX (xcave_synthese_hbox_region[ind]),
			             		  xcave_synthese_entry_region1[ind], TRUE, TRUE, 0);
               gtk_editable_set_editable (GTK_EDITABLE (xcave_synthese_entry_region1[ind]), FALSE);
               gtk_entry_set_invisible_char (GTK_ENTRY (xcave_synthese_entry_region1[ind]), 9679);
               gtk_entry_set_width_chars (GTK_ENTRY (xcave_synthese_entry_region1[ind]), 32);
               gtk_entry_set_text (GTK_ENTRY (xcave_synthese_entry_region1[ind]),tmp_buf);
			
               /*
		* entry number of bottle
		*/
	       memset(tmp_buf,'\0',sizeof(tmp_buf));
               sprintf(tmp_buf,_("%4.0d"),tmp_nb);												  
               xcave_synthese_entry_region2[ind] = gtk_entry_new ();
               gtk_widget_show (xcave_synthese_entry_region2[ind]);
               gtk_box_pack_start (GTK_BOX (xcave_synthese_hbox_region[ind]),
			             		  xcave_synthese_entry_region2[ind], TRUE, TRUE, 0);
               gtk_editable_set_editable (GTK_EDITABLE (xcave_synthese_entry_region2[ind]), FALSE);
               gtk_entry_set_invisible_char (GTK_ENTRY (xcave_synthese_entry_region2[ind]), 9679);
               gtk_entry_set_width_chars (GTK_ENTRY (xcave_synthese_entry_region2[ind]), 4);
               gtk_entry_set_text (GTK_ENTRY (xcave_synthese_entry_region2[ind]),tmp_buf);
							 
	       /*
	        * percent in progressbar
	        */
               gfloat tmp_tx = (tmp_nb * 100) / NbBottleStock;
			   memset(tmp_buf,'\0',sizeof(tmp_buf));
               sprintf(tmp_buf,_("%2.0f %s "),tmp_tx,"%");
               xcave_synthese_progressbar_region[ind] = gtk_progress_bar_new ();
               gtk_progress_bar_set_text(GTK_PROGRESS_BAR(xcave_synthese_progressbar_region[ind]),
										 tmp_buf);
               gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(xcave_synthese_progressbar_region[ind]),
											 tmp_tx/100);
               gtk_box_pack_start (GTK_BOX (xcave_synthese_hbox_region[ind]),
								   xcave_synthese_progressbar_region[ind],
								   FALSE, FALSE, 0);
               gtk_widget_set_size_request (xcave_synthese_progressbar_region[ind], -1, 10);
		       gtk_widget_show (xcave_synthese_progressbar_region[ind]);
        }
    }

    /*
     * RACK STATS
     */
    GtkWidget *xcave_synthese_vbox_rack;
    GtkWidget *xcave_synthese_hbox_rack[rackNb];
    GtkWidget *xcave_synthese_entry_rack1[rackNb];
    GtkWidget *xcave_synthese_entry_rack3[rackNb];
    GtkWidget *xcave_synthese_progressbar_rack[rackNb];
    GtkWidget *xcave_synthese_frame_rack;

    xcave_synthese_frame_rack = lookup_widget(window_synthese,"xcave_synthese_frame_rack");
    xcave_synthese_vbox_rack = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (xcave_synthese_vbox_rack);
    gtk_container_add (GTK_CONTAINER (xcave_synthese_frame_rack), xcave_synthese_vbox_rack);

    for (ind = 0; ind < rackNb; ind++) {
        tmp_nb = calculate_nb_bottle(CALCULATE_RACK,NULL,ind);

	xcave_synthese_hbox_rack[ind] = gtk_hbox_new (FALSE, 0);
        gtk_widget_show (xcave_synthese_hbox_rack[ind]);
        gtk_box_pack_start (GTK_BOX (xcave_synthese_vbox_rack),
                            xcave_synthese_hbox_rack[ind], TRUE, TRUE, 0);

	/* 
	 * entry rack
	 */
	memset(tmp_buf,'\0',sizeof(tmp_buf));
	sprintf(tmp_buf,_("rack %d"),ind+1);
        xcave_synthese_entry_rack1[ind] = gtk_entry_new ();
        gtk_widget_show (xcave_synthese_entry_rack1[ind]);
        gtk_box_pack_start (GTK_BOX (xcave_synthese_hbox_rack[ind]),
                            xcave_synthese_entry_rack1[ind], TRUE, TRUE, 0);
        gtk_editable_set_editable (GTK_EDITABLE (xcave_synthese_entry_rack1[ind]), FALSE);
        gtk_entry_set_invisible_char (GTK_ENTRY (xcave_synthese_entry_rack1[ind]), 9679);
        gtk_entry_set_width_chars (GTK_ENTRY (xcave_synthese_entry_rack1[ind]), 32);
        gtk_entry_set_text (GTK_ENTRY (xcave_synthese_entry_rack1[ind]),tmp_buf);

	/*
	 * entry rack number
	 */
	memset(tmp_buf,'\0',sizeof(tmp_buf));
	sprintf(tmp_buf,_("%4.0d"),tmp_nb);
        xcave_synthese_entry_rack3[ind] = gtk_entry_new ();
        gtk_widget_show (xcave_synthese_entry_rack3[ind]);
        gtk_box_pack_start (GTK_BOX (xcave_synthese_hbox_rack[ind]),
        		    xcave_synthese_entry_rack3[ind], TRUE, TRUE, 0);
        gtk_editable_set_editable (GTK_EDITABLE (xcave_synthese_entry_rack3[ind]), FALSE);
        gtk_entry_set_invisible_char (GTK_ENTRY (xcave_synthese_entry_rack3[ind]), 9679);
        gtk_entry_set_width_chars (GTK_ENTRY (xcave_synthese_entry_rack3[ind]), 4);
        gtk_entry_set_text (GTK_ENTRY (xcave_synthese_entry_rack3[ind]),tmp_buf);

	/*
	 * percent in progressbar
	 */
        gfloat tmp_tx = 0;
        if ( (gint)g_list_nth_data(list_rackRow, ind) != 0
           ||
             (gint)g_list_nth_data(list_rackCol, ind) != 0
           ) {
         tmp_tx = (tmp_nb * 100) / 
                        (
                        (gint)g_list_nth_data(list_rackRow, ind)
                        *			        
                        (gint)g_list_nth_data(list_rackCol, ind)
                        );
        }
	memset(tmp_buf,'\0',sizeof(tmp_buf));
        sprintf(tmp_buf,_("%2.0f %s "),tmp_tx,"%");
        xcave_synthese_progressbar_rack[ind] = gtk_progress_bar_new ();
        gtk_progress_bar_set_text(GTK_PROGRESS_BAR(xcave_synthese_progressbar_rack[ind]),tmp_buf);
	gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(xcave_synthese_progressbar_rack[ind]),tmp_tx/100);
        gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR(xcave_synthese_progressbar_rack[ind]),GTK_PROGRESS_CONTINUOUS);
        gtk_widget_show (xcave_synthese_progressbar_rack[ind]);
        gtk_box_pack_start (GTK_BOX (xcave_synthese_hbox_rack[ind]),
	xcave_synthese_progressbar_rack[ind], FALSE, FALSE, 0);
        gtk_widget_set_size_request (xcave_synthese_progressbar_rack[ind], -1, 10);
        gtk_widget_show (xcave_synthese_progressbar_rack[ind]);
    }
	
	
    XCAVE_DEBUG_E;

}

void
on_xcave_synthese_destroy              (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (window_synthese));

   /* 
    * reactive window_xcave
    */
   gtk_widget_set_sensitive(window_xcave, TRUE);

}

void
on_xcave_synthese_button_close_clicked (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_object_destroy (GTK_OBJECT (window_synthese));

   /* 
    * reactive window_xcave
    */
   gtk_widget_set_sensitive(window_xcave, TRUE);


}

void
on_xcave_synthese_check_resize         (GtkContainer    *container,
                                        gpointer         user_data)
{
   gint height = 0;
   gint width = 0;

   gdk_window_get_size( container->widget.window , &width, &height);

   sprintf(WindowsSyntheseWidth,"%d",width);
   sprintf(WindowsSyntheseHeight,"%d",height);

}

gint
calculate_nb_bottle(gint type, gchar *lib, gint nb)
{
  GList  *tmp_list;
  gint    nb_calc = 0;
	
  switch (type) {
	  case CALCULATE_COLOR:
	     break;
	  case CALCULATE_COUNTRY:
	     break;
	  case CALCULATE_REGION:
	     {
           Vin     tmpVin;
           for(tmp_list  = list_stock; 
			   tmp_list != NULL ; 
			   tmp_list  = tmp_list->next) {
                 memcpy(&tmpVin,tmp_list->data,sizeof(Vin));
	             if (strcasecmp(tmpVin.Region, lib) == 0)
			        nb_calc += tmpVin.qty;
			   }
	     }
	     break;
	  case CALCULATE_APPELLATION:
	     break;		  
	  case CALCULATE_RACK:
	     {
	       Emplacement   tmpEmplacement;
           for(tmp_list  = list_rack; 
			   tmp_list != NULL ; 
			   tmp_list  = tmp_list->next) {
                 memcpy(&tmpEmplacement,tmp_list->data,sizeof(Emplacement));
	             if (tmpEmplacement.Rack == nb) 
			        nb_calc++;
			   }
		 }
	     break;		  
	  case CALCULATE_VINTAGE:
	     break;		  
	  default:
		 break;
  }
  return(nb_calc);
}

